/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2017/18      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : lecture 3
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: race conditions
///
////////////////////////////////////////////////////////////////////////////////////////////////////

// includes, system
#include <iostream>
#include <iomanip>
#include <vector>
#include <thread>
#include <cstdlib>
#include <chrono>
#include <ctime>
#include <cassert>
#include <algorithm>


////////////////////////////////////////////////////////////////////////////////////////////////////
//! Merge sort
////////////////////////////////////////////////////////////////////////////////////////////////////
template<typename T>
void
mergesort( T* data, T* last, T* scratch ) {

}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Merge sort
////////////////////////////////////////////////////////////////////////////////////////////////////
template<typename T>
void
mergesortParallel( T* data, T* last, T* scratch, const int num_threads) {

}


////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  std::srand( std::time(0));

  // allocate memory
  int n = 4096;
  int* data = (int*) malloc( n * sizeof(int));
  int* scratch = (int*) malloc( n * sizeof(int));
  std::generate( data, data + n, std::rand);

  // reference solution
  int* dataref = (int*) malloc( n * sizeof(int));
  memcpy( dataref, data, n * sizeof(int));
  std::sort( dataref, dataref+n);

#if 1
  // run merge sort
  mergesort( data, data+n, scratch);
#endif

#if 0
  // run parallel merge sort
  unsigned int num_threads = std::thread::hardware_concurrency();
  std::cout << "num_threads = " << num_threads << std::endl;
  mergesortParallel( data, data+n, scratch, num_threads);
#endif

  // check correctness of result
  bool correct = true;
  for( int i = 0; i < n; ++i) {
    correct &= (dataref[i] == data[i]);
  }
  std::cout << "Mergesort " << ((correct) ? "succeeded." : "failed.") << std::endl;

  // clean up
  free( data);
  free( scratch);
  free( dataref);

  return EXIT_SUCCESS;
}
